package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.CaseCheckedBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseCheckedModelImpl implements ICaseCheckedModel {

    private OnGetCaseCheckedListener listener;

    public CaseCheckedModelImpl(OnGetCaseCheckedListener caseCheckedListener) {
        this.listener = caseCheckedListener;
    }

    public interface OnGetCaseCheckedListener {
        void onSuccess(CaseCheckedBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(int offset) {
        Observable<CaseCheckedBean> observable = RetrofitServiceManager.getCaseCheckedListResult(offset);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<CaseCheckedBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(CaseCheckedBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
